<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
</head>

<body>
  <canvas id="visual" width="512px" height="255px" style="border: 1px solid black;"></canvas>
  <audio id="audio" controls></audio>

  <script type="text/javascript">
    const visualize = function() {
      audioAnalyzer.getByteFrequencyData(data);
      const averageLoudness = data.reduce((a, b) => a + b, 0) / data.length;
      recordLoudness(averageLoudness);
      draw(averageLoudness);
      // repeat
      setTimeout(visualize, 50);
    }

    const c = document.getElementById('visual').getContext('2d');
    const w = document.getElementById('visual').width;
    const h = document.getElementById('visual').height;
    const audio = document.getElementById('audio');
    const audioContext = new AudioContext() || new webkitAudioContext();
    const audioAnalyzer = audioContext.createAnalyser();
    audioAnalyzer.fftSize = 2 ** 5;
    // need to convert <audio> element into audio node for audio context:
    const source = audioContext.createMediaElementSource(audio);
    // connect all nodes:
    source.connect(audioAnalyzer);
    source.connect(audioContext.destination);
    audio.onplay = () => { audioContext.resume(); }

    // the array with audio data
    const data = new Uint8Array(audioAnalyzer.fftSize / 2);

    // get user media workaround for different browsers
		var getUserMedia = (function () {
			if (navigator.getUserMedia) {
				return navigator.getUserMedia.bind(navigator)
			}
			if (navigator.webkitGetUserMedia) {
				return navigator.webkitGetUserMedia.bind(navigator)
			}
			if (navigator.mozGetUserMedia) {
				return navigator.mozGetUserMedia.bind(navigator)
			}
		})();
    getUserMedia({
      video: false,
      audio: true
    }, function (stream) {
      // console.log('local stream: ', stream)
      playStream(stream);
    }, function (err) {
      console.log('Failed to get local stream', err);
    });

    function playStream(stream) {
      audio.srcObject = stream;
      audio.play();
      requestAnimationFrame(visualize);
    }

    const amp = 10;
    function draw(averageLoudness) {
      c.clearRect(0, 0, w, h);
      c.fillStyle = "purple";
      for (let i=0; i<w; i++) {
        c.fillRect(i-1, h, 1,  -amp * loudnessRecord[i])
      }
    }

    const loudnessRecord = new Array(w);
    function recordLoudness(currentValue) {
      while (loudnessRecord.length >= w) {
        loudnessRecord.shift();
      }
      loudnessRecord.push(currentValue);
    }

  </script>
</body>
</html>
